<template>
    <div>
        <select
            class="uk-select"
            data-uk-form-select
            v-model="typeProbleme"
            @change="changerTypeProbleme()"
            :disabled="disable"
        >
            <option v-if="!affichageVide" :value="'Tous'">
                Tout type d'exercice
            </option>
            <option :value="getValueLibertes()" v-if="!upload">
                Compter les libertés
            </option>
            <option :value="getValueTesuji()">Tesuji</option>
            <option :value="getValueChoixMultiples()" v-if="!upload">
                Choix multiple
            </option>
            <option :value="getValueTsumego()">
                Tsumego
            </option>
            <option :value="getValueJoseki()">
                Joseki
            </option>
            <option :value="getValuePresentation()">
                Presentation
            </option>
        </select>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import * as TypeProbleme from '@/components/constantes/TypeDeProbleme';
import Component from 'vue-class-component';
import { Prop } from 'vue-property-decorator';
@Component
export default class ListeTypeExercice extends Vue {
    @Prop() typeProp: string;
    @Prop() affichageVide: boolean;
    @Prop() disable: boolean;
    @Prop() upload: boolean;

    private typeProbleme = 'Tous';

    mounted() {
        if (this.typeProp) {
            this.typeProbleme = this.typeProp;
        } else {
            this.typeProbleme = this.affichageVide ? '' : 'Tous';
        }
    }

    private getValueLibertes(): string {
        return TypeProbleme.LIBERTES;
    }

    private getValueTesuji(): string {
        return TypeProbleme.TESUJI;
    }
    private getValueChoixMultiples(): string {
        return TypeProbleme.CHOIXMULTIPLE;
    }

    private getValueTsumego(): string {
        return TypeProbleme.TSUMEGO;
    }

    private getValuePresentation(): string {
        return TypeProbleme.PRESENTATION;
    }

    private getValueJoseki(): string {
        return TypeProbleme.JOSEKI;
    }

    private changerTypeProbleme() {
        const type = this.typeProbleme === 'Tous' ? '' : this.typeProbleme;
        this.$emit('action', type);
    }
}
</script>
